#ifndef F3DEX2_H
#define F3DEX2_H

// GeometryMode flags
#define F3DEX2_GEOMETRYMODE_TEXTURE_ENABLE		0x00000000	// Ignored
#define F3DEX2_GEOMETRYMODE_ZBUFFER				0x00000001
#define F3DEX2_GEOMETRYMODE_SHADE				0x00000004	// enable Gouraud interp 

#define F3DEX2_GEOMETRYMODE_CULL_FRONT			0x00000200
#define F3DEX2_GEOMETRYMODE_CULL_BACK			0x00000400
#define F3DEX2_GEOMETRYMODE_CULL_BOTH			0x00000600
#define F3DEX2_GEOMETRYMODE_FOG					0x00010000
#define F3DEX2_GEOMETRYMODE_LIGHTING			0x00020000
#define F3DEX2_GEOMETRYMODE_TEXTURE_GEN			0x00040000
#define F3DEX2_GEOMETRYMODE_TEXTURE_GEN_LINEAR	0x00080000
#define F3DEX2_GEOMETRYMODE_LOD					0x00100000	// NOT IMPLEMENTED 
#define F3DEX2_GEOMETRYMODE_SHADING_SMOOTH		0x00200000	// flat or smooth shaded 
#define F3DEX2_GEOMETYRMODE_CLIPPING			0x00800000

// Matrix Flags
#define	F3DEX2_MTX_MODELVIEW		0x00
#define	F3DEX2_MTX_PROJECTION		0x04

#define	F3DEX2_MTX_MUL				0x00
#define	F3DEX2_MTX_LOAD				0x02

#define F3DEX2_MTX_NOPUSH			0x00
#define F3DEX2_MTX_PUSH				0x01

// DisplayList Flags
#define F3DEX2_DL_PUSH				0x00
#define F3DEX2_DL_NOPUSH			0x01

// MoveWord Types
#define F3DEX2_MOVEWORD_MATRIX		0x00
#define F3DEX2_MOVEWORD_NUMLIGHT 	0x02
#define F3DEX2_MOVEWORD_CLIP		0x04
#define F3DEX2_MOVEWORD_SEGMENT		0x06
#define F3DEX2_MOVEWORD_FOG			0x08
#define F3DEX2_MOVEWORD_LIGHTCOL	0x0a
#define	F3DEX2_MOVEWORD_FORCEMTX	0x0c
#define	F3DEX2_MOVEWORD_PERSPNORM	0x0e

// MoveMem Types
#define F3DEX2_MOVEMEM_MMTX			2	
#define F3DEX2_MOVEMEM_PMTX			6
#define F3DEX2_MOVEMEM_VIEWPORT		8
#define F3DEX2_MOVEMEM_LIGHT		10
#define F3DEX2_MOVEMEM_POINT		12
#define F3DEX2_MOVEMEM_MATRIX		14

// MoveMem offsets
#define F3DEX2_MOVEMEM_OFFSET_LOOKATX	0
#define F3DEX2_MOVEMEM_OFFSET_LOOKATY	24
#define F3DEX2_MOVEMEM_OFFSET_L0		48
#define F3DEX2_MOVEMEM_OFFSET_L1		72
#define F3DEX2_MOVEMEM_OFFSET_L2		96
#define F3DEX2_MOVEMEM_OFFSET_L3		120
#define F3DEX2_MOVEMEM_OFFSET_L4		144
#define F3DEX2_MOVEMEM_OFFSET_L5		168
#define F3DEX2_MOVEMEM_OFFSET_L6		192
#define F3DEX2_MOVEMEM_OFFSET_L7		216

// Modify vertex offsets
#define F3DEX2_POINT_RGBA				0x10
#define F3DEX2_POINT_ST					0x14
#define F3DEX2_POINT_XYSCREEN			0x18
#define F3DEX2_POINT_ZSCREEN			0x1c

void F3DEX2_Init();
#endif